package grammar;

import java.io.*;

%%

%{
	int value;
%}

%public
%class HexValue
%int

%init{
    yybegin( NORMAL );
%init}

newline 	=	\r | \n | \r\n


%state NORMAL, HEX

%%
<NORMAL> {
	0[xX]				{
						yybegin( HEX ); value=0;
						}
	{newline}			{ }
	<<EOF>>				{
						throw new Error( "Completed" );
						}
	.					{ }

	}	
<HEX> {
	[0-9]				{
						value = value * 16 + yytext().charAt(0) - '0';
						}
	[a-f]				{
						value = value * 16 + yytext().charAt(0) - 'a' + 10;
						}
	[A-F]				{
						value = value * 16 + yytext().charAt(0) - 'A' + 10;
						}
	{newline}			{ 
						yybegin( NORMAL ); return value;
						}
	<<EOF>>				{
						yybegin( NORMAL ); return value;
						}
	.					{ 
						yybegin( NORMAL ); return value;
						}
	}
